summaryrefslogtreecommitdiff
path: root/bin
diff options
context:
space:
mode:
authorJonas Smedegaard <dr@jones.dk>2017-04-16 13:32:04 +0200
committerJonas Smedegaard <dr@jones.dk>2017-04-16 13:32:04 +0200
commit46ddda9c56187f452b258e45520db0971dd470b4 (patch)
tree51d16ec28e79ea8b54a4a2840530d93d84614346 /bin
parent0e4445a5330cdf478fe029734fd176689c30a5fd (diff)
Fork decode+edit+encode+stream as decode+edit+loop+encode+stream, and add FIXME that audio is broken.
Diffstat (limited to 'bin')
-rwxr-xr-xbin/decode+edit+loop+encode+stream42
1 files changed, 42 insertions, 0 deletions
diff --git a/bin/decode+edit+loop+encode+stream b/bin/decode+edit+loop+encode+stream
new file mode 100755
index 0000000..686cf55
--- /dev/null
+++ b/bin/decode+edit+loop+encode+stream
@@ -0,0 +1,42 @@
+#!/bin/sh
+
+# FIXME: Handle audio track in main input
+# TODO: Handle audio as secondary input
+
+set -e
+
+HOST=${1:-morla}
+if [ "$HOST" = "$(hostname --short)" ]; then
+ IP=127.0.0.1
+else
+ IP=$(host "$HOST" | grep -Po 'address \K\S+')
+fi
+
+FIRSTPORT=${2:-5002} # even number - next 3 ports used too
+
+ITERATIONS=${3-0} # endless by default
+
+HEIGHT=360
+VBITRATE=500000
+
+MOVIE=../src/omni/show0/earth.mp4
+LOGO=../../content/icon_small.png
+
+# based on http://www.webmproject.org/docs/encoder-parameters/#real-time-cbr-encoding-and-streaming
+# + loop-in-filter trick based on http://video.stackexchange.com/a/16933
+# + scale+watermark trick based on http://stackoverflow.com/a/10937357
+# + Drop frames, aggressively treat as static, and use fastest cpu
+ffmpeg -threads auto -re \
+ -f lavfi -i "movie=filename=$MOVIE:loop=$ITERATIONS, setpts=N/(FRAME_RATE*TB)" \
+ -i "$LOGO" \
+ -filter_complex \
+ "[0:v]scale=-1:$HEIGHT[bg];
+ [bg][1:v]overlay=main_w-overlay_w-20:main_h-overlay_h-20" \
+ -an \
+ -codec:v vp8 -quality realtime -deadline realtime -cpu-used 15 \
+ -b:v "$VBITRATE" -minrate "$VBITRATE" -maxrate "$VBITRATE" \
+ -undershoot-pct 95 -bufsize $((6000*VBITRATE/1000)) -rc_init_occupancy $((4000*VBITRATE/1000)) \
+ -max-intra-rate 0 \
+ -qmin 4 -qmax 56 \
+ -static-thresh 500 -skip_threshold 50 \
+ -f rtp "rtp://$IP:$((FIRSTPORT+2))?pkt_size=1200"